import QtQuick 2.0
import org.shotcut.qml 1.0

Metadata {
    type: Metadata.Filter
    objectName: 'formesimple'
    name: qsTr("Shapes")
    mlt_service: "webvfx"
    isHidden: false
    qml: "ui.qml"
    vui: "vui.qml"
    keyframes {
        allowAnimateIn: true
        allowAnimateOut: true
        simpleProperties: ['rect', 'radius', 'param2', 'fillopacity', 'borderopacity', 'bgopacity', 'rotate']
        parameters: [
            Parameter {
                name: qsTr('Position / Size')
                property: 'rect'
                isSimple: true
                isRectangle: true
            },
            Parameter {
                name: qsTr('Parameter #1')
                property: 'radius'
                isSimple: true
                isCurve: true
                minimum: 0
                maximum: 1
            },
            Parameter {
                name: qsTr('Parameter #2')
                property: 'param2'
                isSimple: true
                isCurve: true
                minimum: 0
                maximum: 100
            },
            Parameter {
                name: qsTr('Shape Opacity')
                property: 'fillopacity'
                isSimple: true
                isCurve: true
                minimum: 0
                maximum: 100
            },
            Parameter {
                name: qsTr('Border Opacity')
                property: 'borderopacity'
                isSimple: true
                isCurve: true
                minimum: 0
                maximum: 100
            },
            Parameter {
                name: qsTr('Background Opacity')
                property: 'bgopacity'
                isSimple: true
                isCurve: true
                minimum: 0
                maximum: 100
            },
            Parameter {
                name: qsTr('Rotation')
                property: 'rotate'
                isSimple: true
                isCurve: true
                minimum: -360
                maximum: 360
            }
        ]
    }
}
