/*
 * Copyright (c) 2019-2020 Meltytech, LLC
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import QtQuick 2.1
import QtQuick.Controls 1.5
import QtQuick.Controls.Styles 1.1
import QtQuick.Layouts 1.0
import QtQuick.Dialogs 1.1
import Shotcut.Controls 1.0

Item {
	width: 550 //600
    height: 450
    property bool blockUpdate: true
    property double startValueRadius: undovalues[4] / 100 // valeur pour Rectangle choisi au début
    property double middleValueRadius: undovalues[4] / 100
    property double endValueRadius: undovalues[4] / 100
    
    property double startValueParam2: undo2values[4] // idem
    property double middleValueParam2: undo2values[4]
    property double endValueParam2: undo2values[4]
    
    property double startValueFillopacity: 100
    property double middleValueFillopacity: 100
    property double endValueFillopacity: 100
    
    property double startValueBorderopacity: 100
    property double middleValueBorderopacity: 100
    property double endValueBorderopacity: 100
    
    property double startValueBgopacity: 0
    property double middleValueBgopacity: 0
    property double endValueBgopacity: 0
    
    property double startValueRotate: 0
    property double middleValueRotate: 0
    property double endValueRotate: 0
    
    property string startValueRect: '_shotcut:startValue'
    property string middleValueRect: '_shotcut:middleValue'
    property string endValueRect:  '_shotcut:endValue'
    property string rectProperty: 'rect'
    property rect filterRect
    
    // Valeurs pour la Combobox
    property var shape : ['Single line', 'Angle', 'Sectors', 'N sides shape', 'Rectangle', 'Rectangle Wrap', 'Circle', 'Circumference', 'Ellipse', 'Triangle', 'Trapezoid', 'Right trapezoid', 'X sides shape', 'Arrow', 'V shape', 'Hexagon', 'Parallelogram', 'Octogon', 'Cross', 'Star', 'Heart']
    
    // Valeurs pour libellé du Slider param1
    property var labelvalues : [labelp1_ligne(), 'Angle', 'Size', 'Deformation', 'Radius', '', 'Arc', 'Circumference', '', 'X adjustment', 'Base width', 'X adjustment', 'Deformation', 'X adjustment','Tip: X position', '', 'X adjustment', 'X adjustment', 'X adjustment', '', '']
	property var undovalues : [100, 50, 50, 50, 30, 10, 75, 75, 0, 50, 50, 50, 50, 50, 50, 0, 30, 60, 66, 0, 0]
	
    // Valeurs pour libellé du Slider param2
	property var labelp2values : [labelp2_ligne(), 'Outline %', 'Outline %', 'Outline %', 'Outline %', 'Outline %', 'Outline %', 'Outline %', 'Outline %', 'Base width', 'X Offset', 'Outline %', 'Outline %', 'Y ajustment', 'Base width', 'Outline %', 'Outline %', 'Y ajustment', 'Y ajustment', 'Outline %', 'Outline %']
	property var undo2values : [50, 10, 10, 10, 10, 10, 10, 10, 10, 100, 50, 10, 10, 50, 10, 10, 10, 60, 66, 10, 10]
	
	// Valeurs pour la Spinbox variantes (0 = Inactive, 1 = Active, 2 = Active + Bouton Help
	property var nb_enab : [  2,  1,  1,  1,  0,  2,  0,  0,  0,   0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0]
	property var nb_vmin : [  1,  1,  1,  3,  1, -2,  1,  1,  1,   1,  1,  1,  4,  1,  1,  1,  1,  1,  1,  1,  1]
	property var nb_vmax : [  12,  4, 24, 24, 24, 15, 24, 24, 24, 24, 24, 24, 10, 24, 50, 24, 24, 24, 24, 24, 24]
	property var nb_step : [  1,  1,  1,  1,  1,  1,  1,  1,  1,   0,  1,  1,  2,  1,  1,  1,  1,  1,  1,  1,  1]
	
    Component.onCompleted: {
        filter.blockSignals = true
        filter.set('mlt_resolution_scale', 1)
        filter.set(startValueRect, Qt.rect(profile.width*0.25, profile.height*0.25, profile.width*0.5, profile.height*0.5))
        filter.set(middleValueRect, Qt.rect(profile.width*0.25, profile.height*0.25, profile.width*0.5, profile.height*0.5))
        filter.set(endValueRect, Qt.rect(profile.width*0.25, profile.height*0.25, profile.width*0.5, profile.height*0.5))
        if (filter.isNew) {
            filter.set('forme', 'Rectangle')
            filter.set('resource', filter.path + 'filter-shape.html')
            // Set default parameter values
            filter.set('aretes', 'miter')
            filter.set('fillcolor', '#FF000000')
            filter.set('fillopacity', 100)
            filter.set('bordercolor', '#FFFF0000')
            filter.set('borderopacity', 100)
            filter.set('color', '#00000000')
            filter.set('bgopacity', 0)
            filter.set('transparent', 0)
            filter.set('radius', undovalues[4] / 100) // valeur pour Rectangle choisi plus haut
            filter.set('param2', undo2values[4]) // idem
            filter.set('border', 5)
            filter.set('propor', 0)
            filter.set('number', 1)
            filter.set('rotate', 0)
            filter.set('_booster', '0')
            filter.set('_vuivisible', '0')
            filter.set('_ratio', profile.width / profile.height)
            filter.set(rectProperty, '25%/25%:50%x50%') // Doit être équivalent aux valeurs fixées ci-dessus.
            //filter.savePreset(preset.parameters)
        } 
        else {
            middleValueRadius = filter.getDouble('radius', filter.animateIn)
            middleValueParam2 = filter.getDouble('param2', filter.animateIn)
            middleValueFillopacity = filter.getDouble('fillopacity', filter.animateIn)
            middleValueBorderopacity = filter.getDouble('borderopacity', filter.animateIn)
            middleValueBgopacity = filter.getDouble('bgopacity', filter.animateIn)
            middleValueRotate = filter.getDouble('rotate', filter.animateIn)
            filter.set(middleValueRect, filter.getRect(rectProperty, filter.animateIn + 1))
            if (filter.animateIn > 0) {
                startValueRadius = filter.getDouble('radius', 0)
                startValueParam2 = filter.getDouble('param2', 0)
                startValueFillopacity = filter.getDouble('fillopacity', 0)
                startValueBorderopacity = filter.getDouble('borderopacity', 0)
                startValueBgopacity = filter.getDouble('bgopacity', 0)
                startValueRotate = filter.getDouble('rotate', 0)
                filter.set(startValueRect, filter.getRect(rectProperty, 0))
            }
            if (filter.animateOut > 0) {
                endValueRadius = filter.getDouble('radius', filter.duration - 1)
                endValueParam2 = filter.getDouble('param2', filter.duration - 1)
                endValueFillopacity = filter.getDouble('fillopacity', filter.duration - 1)
                endValueBorderopacity = filter.getDouble('borderopacity', filter.duration - 1)
                endValueBgopacity = filter.getDouble('bgopacity', filter.duration - 1)
                endValueRotate = filter.getDouble('rotate', filter.duration - 1)
                filter.set(endValueRect, filter.getRect(rectProperty, filter.duration - 1))
            }
        }
        //filter.blockSignals = false
        if (filter.get('_booster') == '1') booster.checked = false
        else booster.checked = true
        if (filter.get('_vuivisible') == '1') vuivisible.checked = false
        else vuivisible.checked = true
        //bgcolorSwatch.value= filter.get('color')
        refclip.checked = (filter.get('transparent') == 1)? true : false
        contour.value = filter.get('border')
        if (filter.get('propor') == 1) {
            proportionid.checked = true
        } 
        else {
            proportionid.checked = false
        }
        nombre.value = filter.get('number')
        centerRadioButton.checked = true
        middleRadioButton.checked = true
        fillRadioButton.checked = true
        
// **** Recherche de la forme dans la liste pour régler la combobox *************
        for (var i = 0; i < shape.length; i ++) { 
        	if (shape[i] === filter.get('forme')) { 
        		formeCombo.currentIndex = i
        	}
        }
        
// **** Recherche du type d'arête pour régler la combobox *************
        aretesCombo.currentIndex = 0
        for (var i = 0; i < 3; i ++) { 
        	if (['miter', 'round', 'bevel'][i] === filter.get('aretes')) { 
        		aretesCombo.currentIndex = i
        	}
        }
        
        filter.blockSignals = false
        setRadiusControls()
        setParam2Controls()
        setFillopacityControls()
        setBorderopacityControls()
        setBgopacityControls()
        setRotateControls()
        setRectControls()
        
        mastercolorSwatch.value = fillcolorSwatch.value = setOpacity(filter.get('fillcolor'), fillopacityid.value)
        bordercolorSwatch.value = setOpacity(filter.get('bordercolor'), borderopacityid.value)
        bgcolorSwatch.value = setOpacity(filter.get('color'), bgopacityid.value)
        
        distortCheckbox.checked = (filter.get('_ratio') == 0 || filter.keyframeCount(rectProperty) > 0)? false : true
        
        if (filter.isNew) {
            filter.set(rectProperty, filter.getRect(rectProperty))
        }
    }

    function getPosition() {
        return Math.max(producer.position - (filter.in - producer.in), 0)
    }

    function setRadiusControls() {
        //if (label_p1.text == "") return
        var position = getPosition()
        blockUpdate = true
        slider.value = filter.getDouble('radius', position) * slider.maximumValue
        blockUpdate = false
        //slider.enabled = position <= 0 || (position >= (filter.animateIn - 1) && position <= (filter.duration - filter.animateOut)) || position >= (filter.duration - 1)
        radiusKeyframesButton.checked = filter.keyframeCount('radius') > 0 && filter.animateIn <= 0 && filter.animateOut <= 0
    }

    function setParam2Controls() {
        if (label_p2.text == "") return
        var position = getPosition()
        blockUpdate = true
        param2id.value = filter.getDouble('param2', position)
        blockUpdate = false
        //param2id.enabled = position <= 0 || (position >= (filter.animateIn - 1) && position <= (filter.duration - filter.animateOut)) || position >= (filter.duration - 1)
        param2KeyframesButton.checked = filter.keyframeCount('param2') > 0 && filter.animateIn <= 0 && filter.animateOut <= 0
    }
    
    function setFillopacityControls() {
        var position = getPosition()
        blockUpdate = true
        fillopacityid.value = filter.getDouble('fillopacity', position)
        blockUpdate = false
        fillopacityid.enabled = position <= 0 || (position >= (filter.animateIn - 1) && position <= (filter.duration - filter.animateOut)) || position >= (filter.duration - 1)
        fillopacityKeyframesButton.checked = filter.keyframeCount('fillopacity') > 0 && filter.animateIn <= 0 && filter.animateOut <= 0
    }

    function setBorderopacityControls() {
        var position = getPosition()
        blockUpdate = true
        borderopacityid.value = filter.getDouble('borderopacity', position)
        blockUpdate = false
        borderopacityid.enabled = position <= 0 || (position >= (filter.animateIn - 1) && position <= (filter.duration - filter.animateOut)) || position >= (filter.duration - 1)
        borderopacityKeyframesButton.checked = filter.keyframeCount('borderopacity') > 0 && filter.animateIn <= 0 && filter.animateOut <= 0
    }

    function setBgopacityControls() {
        var position = getPosition()
        blockUpdate = true
        bgopacityid.value = filter.getDouble('bgopacity', position)
        blockUpdate = false
        bgopacityid.enabled = position <= 0 || (position >= (filter.animateIn - 1) && position <= (filter.duration - filter.animateOut)) || position >= (filter.duration - 1)
        bgopacityKeyframesButton.checked = filter.keyframeCount('bgopacity') > 0 && filter.animateIn <= 0 && filter.animateOut <= 0
    }

    function setRotateControls() {
        var position = getPosition()
        blockUpdate = true
        rotateslider.value = filter.getDouble('rotate', position)
        blockUpdate = false
        rotateslider.enabled = position <= 0 || (position >= (filter.animateIn - 1) && position <= (filter.duration - filter.animateOut)) || position >= (filter.duration - 1)
        rotateKeyframesButton.checked = filter.keyframeCount('rotate') > 0 && filter.animateIn <= 0 && filter.animateOut <= 0
    }

    function setRectControls() {
        var position = getPosition()
        var newValue = filter.getRect(rectProperty, position)
        if (filterRect !== newValue) {
            filterRect = newValue
            rectX.value = filterRect.x.toFixed()
            rectY.value = filterRect.y.toFixed()
            rectW.value = filterRect.width.toFixed()
            rectH.value = filterRect.height.toFixed()
            scaleSlider.value = rectW.value / profile.width * 100
        }
        var enabled = position <= 0 || (position >= (filter.animateIn - 1) && position <= (filter.duration - filter.animateOut)) || position >= (filter.duration - 1)
        rectX.enabled = enabled
        rectY.enabled = enabled
        rectW.enabled = enabled
        rectH.enabled = enabled
    }
    
    function updateFilterRadius(position) {
        //if (label_p1.text == "") return
        if (blockUpdate) return
        var value = slider.value / 100.0

        if (position !== null) {
            if (position <= 0 && filter.animateIn > 0) {
                startValueRadius = value
            } else if (position >= filter.duration - 1 && filter.animateOut > 0) {
                endValueRadius = value
            } else {
                middleValueRadius = value
            }
        }

        if (filter.animateIn > 0 || filter.animateOut > 0) {
            filter.resetProperty('radius')
            radiusKeyframesButton.checked = false
            if (filter.animateIn > 0) {
                filter.set('radius', startValueRadius, 0)
                filter.set('radius', middleValueRadius, filter.animateIn - 1)
            }
            if (filter.animateOut > 0) {
                filter.set('radius', middleValueRadius, filter.duration - filter.animateOut)
                filter.set('radius', endValueRadius, filter.duration - 1)
            }
        } else if (!radiusKeyframesButton.checked) {
            filter.resetProperty('radius')
            filter.set('radius', middleValueRadius)
        } else if (position !== null) {
            filter.set('radius', value, position)
        }
    }

    function updateFilterParam2(position) {
        //if (label_p2.text == "") return
        if (blockUpdate) return
        var value = param2id.value

        if (position !== null) {
            if (position <= 0 && filter.animateIn > 0) {
                startValueParam2 = value
            } else if (position >= filter.duration - 1 && filter.animateOut > 0) {
                endValueParam2 = value
            } else {
                middleValueParam2 = value
            }
        }

        if (filter.animateIn > 0 || filter.animateOut > 0) {
            filter.resetProperty('param2')
            param2KeyframesButton.checked = false
            if (filter.animateIn > 0) {
                filter.set('param2', startValueParam2, 0)
                filter.set('param2', middleValueParam2, filter.animateIn - 1)
            }
            if (filter.animateOut > 0) {
                filter.set('param2', middleValueParam2, filter.duration - filter.animateOut)
                filter.set('param2', endValueParam2, filter.duration - 1)
            }
        } else if (!param2KeyframesButton.checked) {
            filter.resetProperty('param2')
            filter.set('param2', middleValueParam2)
        } else if (position !== null) {
            filter.set('param2', value, position)
        }
    }
    
    function updateFilterFillopacity(position) {
        if (blockUpdate) return
        var value = fillopacityid.value

        if (position !== null) {
            if (position <= 0 && filter.animateIn > 0) {
                startValueFillopacity = value
            } else if (position >= filter.duration - 1 && filter.animateOut > 0) {
                endValueFillopacity = value
            } else {
                middleValueFillopacity = value
            }
        }

        if (filter.animateIn > 0 || filter.animateOut > 0) {
            filter.resetProperty('fillopacity')
            fillopacityKeyframesButton.checked = false
            if (filter.animateIn > 0) {
                filter.set('fillopacity', startValueFillopacity, 0)
                filter.set('fillopacity', middleValueFillopacity, filter.animateIn - 1)
            }
            if (filter.animateOut > 0) {
                filter.set('fillopacity', middleValueFillopacity, filter.duration - filter.animateOut)
                filter.set('fillopacity', endValueFillopacity, filter.duration - 1)
            }
        } else if (!fillopacityKeyframesButton.checked) {
            filter.resetProperty('fillopacity')
            filter.set('fillopacity', middleValueFillopacity)
        } else if (position !== null) {
            filter.set('fillopacity', value, position)
        }
    }

    function updateFilterBorderopacity(position) {
        if (blockUpdate) return
        var value = borderopacityid.value

        if (position !== null) {
            if (position <= 0 && filter.animateIn > 0) {
                startValueBorderopacity = value
            } else if (position >= filter.duration - 1 && filter.animateOut > 0) {
                endValueBorderopacity = value
            } else {
                middleValueBorderopacity = value
            }
        }

        if (filter.animateIn > 0 || filter.animateOut > 0) {
            filter.resetProperty('borderopacity')
            borderopacityKeyframesButton.checked = false
            if (filter.animateIn > 0) {
                filter.set('borderopacity', startValueBorderopacity, 0)
                filter.set('borderopacity', middleValueBorderopacity, filter.animateIn - 1)
            }
            if (filter.animateOut > 0) {
                filter.set('borderopacity', middleValueBorderopacity, filter.duration - filter.animateOut)
                filter.set('borderopacity', endValueBorderopacity, filter.duration - 1)
            }
        } else if (!borderopacityKeyframesButton.checked) {
            filter.resetProperty('borderopacity')
            filter.set('borderopacity', middleValueBorderopacity)
        } else if (position !== null) {
            filter.set('borderopacity', value, position)
        }
    }

    function updateFilterBgopacity(position) {
        if (blockUpdate) return
        var value = bgopacityid.value

        if (position !== null) {
            if (position <= 0 && filter.animateIn > 0) {
                startValueBgopacity = value
            } else if (position >= filter.duration - 1 && filter.animateOut > 0) {
                endValueBgopacity = value
            } else {
                middleValueBgopacity = value
            }
        }

        if (filter.animateIn > 0 || filter.animateOut > 0) {
            filter.resetProperty('bgopacity')
            bgopacityKeyframesButton.checked = false
            if (filter.animateIn > 0) {
                filter.set('bgopacity', startValueBgopacity, 0)
                filter.set('bgopacity', middleValueBgopacity, filter.animateIn - 1)
            }
            if (filter.animateOut > 0) {
                filter.set('bgopacity', middleValueBgopacity, filter.duration - filter.animateOut)
                filter.set('bgopacity', endValueBgopacity, filter.duration - 1)
            }
        } else if (!bgopacityKeyframesButton.checked) {
            filter.resetProperty('bgopacity')
            filter.set('bgopacity', middleValueBgopacity)
        } else if (position !== null) {
            filter.set('bgopacity', value, position)
        }
    }

    function updateFilterRotate(position) {
        if (blockUpdate) return
        var value = rotateslider.value

        if (position !== null) {
            if (position <= 0 && filter.animateIn > 0) {
                startValueRotate = value
            } else if (position >= filter.duration - 1 && filter.animateOut > 0) {
                endValueRotate = value
            } else {
                middleValueRotate = value
            }
        }

        if (filter.animateIn > 0 || filter.animateOut > 0) {
            filter.resetProperty('rotate')
            rotateKeyframesButton.checked = false
            if (filter.animateIn > 0) {
                filter.set('rotate', startValueRotate, 0)
                filter.set('rotate', middleValueRotate, filter.animateIn - 1)
            }
            if (filter.animateOut > 0) {
                filter.set('rotate', middleValueRotate, filter.duration - filter.animateOut)
                filter.set('rotate', endValueRotate, filter.duration - 1)
            }
        } else if (!rotateKeyframesButton.checked) {
            filter.resetProperty('rotate')
            filter.set('rotate', middleValueRotate)
        } else if (position !== null) {
            filter.set('rotate', value, position)
        }
    }

    function updateFilterRect(position) {
        var rect

        if (position !== null) {
            filter.blockSignals = true
            if (position <= 0 && filter.animateIn > 0) {
                filter.set(startValueRect, filterRect)
            } else if (position >= filter.duration - 1 && filter.animateOut > 0) {
                filter.set(endValueRect, filterRect)
            } else {
                filter.set(middleValueRect, filterRect)
            }
            filter.blockSignals = false
        }

        if (filter.animateIn > 0 || filter.animateOut > 0) {
            filter.resetProperty(rectProperty)
            positionKeyframesButton.checked = false
            if (filter.animateIn > 0) {
                rect = filter.getRect(startValueRect)
                filter.set(rectProperty, rect, 1.0, 0)
                rect = filter.getRect(middleValueRect)
                filter.set(rectProperty, rect, 1.0, filter.animateIn - 1)
            }
            if (filter.animateOut > 0) {
                rect = filter.getRect(middleValueRect)
                filter.set(rectProperty, rect, 1.0, filter.duration - filter.animateOut)
                rect = filter.getRect(endValueRect)
                filter.set(rectProperty, rect, 1.0, filter.duration - 1)
            }
        } else if (!positionKeyframesButton.checked) {
            filter.resetProperty(rectProperty)
            rect = filter.getRect(middleValueRect)
            filter.set(rectProperty, rect)
        } else if (position !== null) {
            filter.set(rectProperty, filterRect, 1.0, position)
        }
    }
    
    function getOpacity(mltColor) {
        var a = parseInt(mltColor.substring(1, 3), 16);
        return Math.round(a/2.55);
    }
    
    function setOpacity(mltColor, opa) {
        var opastr = (mltColor.length > 7)? Math.round(opa*2.55).toString(16) : "FF";
        if ((opastr.length % 2) > 0) {
            opastr = "0" + opastr;
        }
        var suite = (mltColor.length > 7)? mltColor.substring(3, 9) : mltColor.substring(1, 7);
        return '#' + opastr + suite;
    }
    
    ExclusiveGroup { id: halignGroup }
    ExclusiveGroup { id: valignGroup }
    ExclusiveGroup { id: colorGroup }
    
    /*TabView {
        anchors.horizontalCenter: parent.horizontalCenter
        width: 540
        height: 430
        anchors.top: parent.top
        anchors.topMargin: 10
        style: TabViewStyle {
            frameOverlap: 1
            frame: Rectangle { color: "#3A3A3A" } //434343
        }
    } // en essai//*/

    GridLayout {
        columns: 6
        
        //Version centrée
        anchors.horizontalCenter: parent.horizontalCenter
        
        //Version cadrée à gauche
        //anchors.left: parent.left
        //anchors.margins: 8
        
        anchors.top: parent.top
        anchors.topMargin: 20 
        
        //==== Ligne Forme ====
        RowLayout {
            Layout.maximumWidth: 100
            ToolButton {
            	Layout.preferredWidth: 26
				Layout.preferredHeight: 26
				iconName: 'task-attempt'
				iconSource: 'qrc:///icons/oxygen/32x32/status/task-attempt.png'
				tooltip: qsTr('Click here for important information\nabout filters using WebVfx')
            	onClicked: helpDialog.visible = true
        		MessageDialog {
        			id: helpDialog
        			visible: false
        			modality: Qt.ApplicationModal
        			icon: StandardIcon.Information
        			text: qsTr("<u>Filters using <b>WebVfx</b></u> :<p>"
					+ "Filters that use <b>WebVfx</b> often crash Shotcut when closing a project "
					+ "or quitting the program.<p>Before quitting or closing the project, save "
					+ "it if necessary, then click on another clip (which does not have a "
					+ "WebVfx filter) to select it. You must also move the playhead away "
					+ "from the clip so that it is not displayed in the player.<p>"
					+ "You should then be able to close the project or quit Shotcut without "
					+ "any problems.<br>")
            		standardButtons: StandardButton.Ok
    			}
        	}
        	Item { Layout.fillWidth: true }
        	Label { 
            	text: 'Shape'
            }
        }
        RowLayout {
            Layout.columnSpan: 4
            //Label { text: qsTr('Forme') }
            ComboBox {
            	id: formeCombo
            	implicitWidth: 160
            	model: shape
            	onActivated: {
            		if (index >= 0) {
            			filter.set('forme', model[index])
            			
            			//filter.resetProperty('radius')
            			slider.value = undovalues[index]
            			radiusKeyframesButton.checked = false
            			filter.set('radius', slider.value / 100)
            			
            			param2id.value = undo2values[index]
            			//filter.resetProperty('param2')
            			filter.set('param2', param2id.value)
            			param2KeyframesButton.checked = false
            			
            			if (nb_enab[index] >= 1) { // Si Spinbox variantes active
            			    if (nb_vmin[index] > nombre.value) nombre.value = nb_vmin[index]
            			    if (nb_vmax[index] < nombre.value) nombre.value = nb_vmax[index]
            			}
            			if (currentIndex == 12) { // Si Forme X cotés, corriger valeur si nécessaire
                            const possibles = [4, 6, 8, 10, 25]
                            var found = possibles.find(checkValu)
                            function checkValu(valu) {
                                return valu >= filter.get('number')
                            }
                            nombre.value = Math.min(found, 10)
                            filter.set('number', nombre.value)
                        }
                        //updateFilterRect(getPosition(), true)
            		    //updateFilterRadius(getPosition())
            		    //updateFilterParam2(getPosition())
            		    //updateFilterFillopacity(getPosition())
            		}
                }
        	}
        	SpinBox {
            	id: nombre
            	Layout.preferredWidth: 43
            	enabled: (nb_enab[formeCombo.currentIndex] >= 1)? true : false
            	decimals: 0
            	minimumValue: nb_vmin[formeCombo.currentIndex]
           		maximumValue: nb_vmax[formeCombo.currentIndex]
           		stepSize: nb_step[formeCombo.currentIndex]
            	Keys.onEnterPressed: focus = false
            	Keys.onReturnPressed: focus = false
            	onValueChanged: {    
                	filter.set('number', value)
                	//param2id.value = undo2values[formeCombo.currentIndex]
                    //filter.resetProperty('param2')
                    //param2KeyframesButton.checked = false
                    //updateFilterParam2(getPosition())
            	}
        	}
        	Label { 
                //Layout.fillWidth: true
                text: {
                    (formeCombo.currentIndex <= 1)? " Variants: " : 
                    (formeCombo.currentIndex == 5)? "Sides variants: " : 
                    "No of entities"
                }
                opacity: (nombre.enabled)? 1 : 0
                //font.pointSize: font.pointSize - 2
                //font.italic : true
            }
            
            ToolButton {
                //Layout.fillWidth: true
                visible: (nb_enab[formeCombo.currentIndex] == 2)? 1 : 0
				implicitWidth: 26
            	implicitHeight: 26
            	iconName: 'help-about'
            	iconSource: 'qrc:///icons/oxygen/32x32/actions/help-about.png'
            	tooltip: qsTr('Instructions about this Shape')
            	onClicked: {
            	    if (formeCombo.currentIndex == 0) help_Ligne_Dialog.visible = true
            	    if (formeCombo.currentIndex == 5) help_Habillage_Dialog.visible = true
        		}
        	}
        	//Item { Layout.fillWidth: true }
            Label { 
        	    Layout.fillWidth: true
        	    horizontalAlignment: Text.AlignRight
        	    text: "VUI" 
        	}
        }
        RowLayout {
             ToggleButton {
                id: vuivisible
                implicitWidth: 26
                implicitHeight: 20
                iconName: checked ? 'layer-visible-on' : 'layer-visible-off'
                iconSource: checked ? 'qrc:///icons/oxygen/32x32/actions/layer-visible-on.png' : 'qrc:///icons/oxygen/32x32/actions/layer-visible-off.png'
                tooltip: qsTr('Show / Hide the VUI')
                onClicked: {
                    if (checked) filter.set('_vuivisible', '0')
                    else filter.set('_vuivisible', '1')
                }
            }
        }
        
        //==== Double l'interligne ====
        Item { 
                Layout.columnSpan: 6
                height : 1
                Layout.fillWidth: true
            }

        //==== Ligne Position ====
        Label {
            text: qsTr('Position')
            Layout.alignment: Qt.AlignRight
        }
        RowLayout {
            Layout.columnSpan: 4
            Layout.alignment: Qt.AlignLeft
            Label { 
            	Layout.preferredWidth : 50
            	horizontalAlignment: Text.AlignRight
            	text: 'X' 
            }
            SpinBox {
                id: rectX
                Layout.minimumWidth: 90
                minimumValue: - profile.width * 2.05
                maximumValue: profile.width * 1.01
                decimals: 0
                stepSize: (booster.checked)? 10 : 1
                Keys.onEnterPressed: focus = false
                Keys.onReturnPressed: focus = false
                onValueChanged: {
                    if ((hovered || activeFocus) && Math.abs(filterRect.x - value) >= 1) {
                        filterRect.x = value
                        updateFilterRect(getPosition(), true)
                    }
                }
            }
            Label { 
            	Layout.preferredWidth : 50
            	horizontalAlignment: Text.AlignRight
            	text: 'Y' 
            }
            SpinBox {
                id: rectY
                Layout.minimumWidth: 90
                minimumValue: - profile.height * 2.05
                maximumValue: profile.height * 1.01
                decimals: 0
                stepSize: (booster.checked)? 10 : 1
                Keys.onEnterPressed: focus = false
                Keys.onReturnPressed: focus = false
                onValueChanged: {
                    if ((hovered || activeFocus) && Math.abs(filterRect.y - value) >= 1) {
                        filterRect.y = value
                        updateFilterRect(getPosition(), true)
                    }
                }
            }
            CheckBox {
                id: booster
                implicitWidth: 26
            	tooltip: qsTr('Spinboxes steps: 1x or 10x')
            	onClicked: {
            	    if (checked) filter.set('_booster', '0')
            	    else filter.set('_booster', '1')
            	}
                style: CheckBoxStyle {
                    indicator: Rectangle {
                        implicitWidth: 26
                        implicitHeight: 20
                        radius: 3
                        color: control.checked? activePalette.highlight : activePalette.button
                        border.color: activePalette.shadow
                        border.width: 1
                        Text {
                            anchors.fill: parent
                            horizontalAlignment: Text.AlignHCenter
                            verticalAlignment: Text.AlignVCenter
                            font.pointSize: (application.OS === 'OS X')? 11 : 8
                            font.bold : true
                            color: activePalette.text
                            text: (control.checked)? qsTr('10x') : qsTr('1x')
                        }
                    }
                }
            }
            Item { Layout.fillWidth: true }
            UndoButton {
                onClicked: {
                    rectX.value = rectY.value = 0
                    filterRect.x = filterRect.y = 0
                    updateFilterRect(getPosition(), true)
                }
            }
        }
        KeyframesButton {
            id: positionKeyframesButton
            Layout.rowSpan: 2
            checked: filter.keyframeCount(rectProperty) > 0 && filter.animateIn <= 0 && filter.animateOut <= 0
            onToggled: {
                if (checked) {
                    filter.blockSignals = true
                    filter.clearSimpleAnimation(rectProperty)
                    filter.blockSignals = false
                    filter.set(rectProperty, filterRect, 1.0, getPosition())
                } else {
                    filter.resetProperty(rectProperty)
                    filter.set(rectProperty, filterRect)
                }
                checked = filter.keyframeCount(rectProperty) > 0 && filter.animateIn <= 0 && filter.animateOut <= 0
            }
        }
    
        //==== Ligne Dimensions ====
        Label {
            text: qsTr('Size')
            Layout.alignment: Qt.AlignRight
        }
        RowLayout {
            Layout.columnSpan: 4
            Label { 
            	Layout.preferredWidth : 50
            	horizontalAlignment: Text.AlignRight
            	text: 'W' 
            }
            SpinBox {
                id: rectW
                Layout.minimumWidth: 90
                minimumValue: 0//contour.value
               	maximumValue: profile.width * 3
               	decimals: 0
                stepSize: (booster.checked)? 10 : 1
                Keys.onEnterPressed: focus = false
                Keys.onReturnPressed: focus = false
                onValueChanged: {
                	if ((hovered || activeFocus) && Math.abs(filterRect.width - value) >= 1) {
                        var centerX = filterRect.x + filterRect.width / 2
                        var rightX = filterRect.x + filterRect.width
                        filterRect.width = value
                        if (centerRadioButton.checked) {
                            filterRect.x = rectX.value = centerX - filterRect.width / 2
                        } else if (rightRadioButton.checked) {
                            filterRect.x = rectX.value = rightX - filterRect.width
                        }
                        if (distortCheckbox.checked) {
                            var middleY = filterRect.y + filterRect.height / 2
                            var bottomY = filterRect.y + filterRect.height
                            filterRect.height = rectH.value = Math.round(value / filter.get('_ratio'))
                            if (middleRadioButton.checked) {
                                filterRect.y = rectY.value = middleY - filterRect.height / 2
                            }
                            else if (bottomRadioButton.checked) {
                                filterRect.y = rectY.value = bottomY - filterRect.height
                            }
                            blockUpdate = true
                            scaleSlider.value = Math.min(rectW.value / profile.width * 100, scaleSlider.maximumValue)
                            blockUpdate = false
                        }
                        updateFilterRect(getPosition(), true)
                    }
                    else if (!(hovered || rectH.hovered || scaleSliderMouseArea.containsMouse)) {
                        distortCheckbox.checked = false
                    }
                }
            }
    		Label { 
            	Layout.preferredWidth : 50
            	horizontalAlignment: Text.AlignRight
            	text: 'H' 
            }
            SpinBox {
                id: rectH
                Layout.minimumWidth: 90
                minimumValue: 0//contour.value
               	maximumValue: profile.height * 3
               	decimals: 0
                stepSize: (booster.checked)? 10 : 1
                Keys.onEnterPressed: focus = false
                Keys.onReturnPressed: focus = false
                onValueChanged: {
                	if ((hovered || activeFocus) && Math.abs(filterRect.height - value) >= 1) {
                        var middleY = filterRect.y + filterRect.height / 2
                        var bottomY = filterRect.y + filterRect.height
                        filterRect.height = value
                        if (middleRadioButton.checked) {
                            filterRect.y = rectY.value = middleY - filterRect.height / 2
                        } else if (bottomRadioButton.checked) {
                            filterRect.y = rectY.value = bottomY - filterRect.height
                        }
                        if (distortCheckbox.checked) {
                            var centerX = filterRect.x + filterRect.width / 2
                            var rightX = filterRect.x + filterRect.width
                            filterRect.width = rectW.value = Math.round(value * filter.get('_ratio'))
                            if (centerRadioButton.checked) {
                                filterRect.x = rectX.value = centerX - filterRect.width / 2
                            }
                            else if (rightRadioButton.checked) {
                                filterRect.x = rectX.value = rightX - filterRect.width
                            }
                            blockUpdate = true
                            scaleSlider.value = Math.min(filterRect.width / profile.width * 100, scaleSlider.maximumValue)
                            blockUpdate = false
                        }
                        updateFilterRect(getPosition(), true)
                    }
                    else if (!(hovered || rectW.hovered || scaleSliderMouseArea.containsMouse)) {
                        distortCheckbox.checked = false
                    }
                }
            }
            ToggleButton {
                id: distortCheckbox
                implicitWidth: 26
            	implicitHeight: 20
            	Layout.alignment: Qt.AlignCenter
            	iconName: (checked)? 'object-locked' : 'object-unlocked'
                iconSource: (checked)? 'qrc:///icons/oxygen/32x32/actions/object-locked.png' : 'qrc:///icons/oxygen/32x32/actions/object-unlocked.png'
                tooltip: qsTr('Lock the current ratio')
                onClicked: {
                    if (checked) {
                        filter.set('_ratio', filterRect.width / filterRect.height)
                        scaleSlider.value = Math.min(filterRect.width / profile.width * 100, scaleSlider.maximumValue)
                    }
                    else filter.set('_ratio', 0)
                	/*filterRect.height = rectH.value
                	var centerX = filterRect.x + filterRect.width / 2
                    var rightX = filterRect.x + filterRect.width
                    if (checked) {
                    	filterRect.width = rectW.value = Math.round(filterRect.height * profile.width / profile.height)
                    }
                	else {
                		filterRect.width = rectW.value = rectH.value
                	}
                	if (centerRadioButton.checked) {
                        filterRect.x = rectX.value = centerX - filterRect.width / 2
                    }
                    else if (rightRadioButton.checked) {
                        filterRect.x = rectX.value = rightX - filterRect.width
                    }
                	scaleSlider.value = rectW.value / profile.width * 100
                	updateFilterRect(getPosition(), true)//*/
                }
        	}
        	Item { Layout.fillWidth: true }
        	UndoButton {
                onClicked: {
                    filterRect.width = rectW.value = profile.width
                    filterRect.height = rectH.value = profile.height
                    scaleSlider.value = Math.min(filterRect.width / profile.width * 100, scaleSlider.maximumValue)
                    updateFilterRect(getPosition(), true)
                }
            }
        }
        
        //==== Ligne Echelle ====
        Label {
            text: qsTr('Scale')
            Layout.alignment: Qt.AlignRight
        }
        RowLayout {
            Layout.columnSpan: 4
            Layout.preferredWidth: 380
            SliderSpinner {
                id: scaleSlider
                minimumValue: 0
                maximumValue: 100 * 3
                value: rectW.value / profile.width * 100
                decimals: 1
                spinnerWidth: 90
                suffix: ' %'
                enabled: distortCheckbox.checked
                Keys.onEnterPressed: formeCombo.forceActiveFocus()
                Keys.onReturnPressed: formeCombo.forceActiveFocus()
                onValueChanged: {
                    if (!blockUpdate && Math.abs(value - filterRect.width * 100 / profile.width) > 0.1) {
                        var centerX = filterRect.x + filterRect.width / 2
                        var rightX = filterRect.x + filterRect.width
                        filterRect.width = rectW.value = (profile.width * scaleSlider.value / 100)
                        if (centerRadioButton.checked) {
                            filterRect.x = rectX.value = centerX - filterRect.width / 2
                        } else if (rightRadioButton.checked) {
                            filterRect.x = rectX.value = rightX - filterRect.width
                        }
                        var middleY = filterRect.y + filterRect.height / 2
                        var bottomY = filterRect.y + filterRect.height
                        //filterRect.height = rectH.value = Math.round(filterRect.width / producer.displayAspectRatio)
                        filterRect.height = rectH.value = Math.round(filterRect.width / filter.get('_ratio'))
                        if (middleRadioButton.checked) {
                            filterRect.y = rectY.value = middleY - filterRect.height / 2
                        } else if (bottomRadioButton.checked) {
                            filterRect.y = rectY.value = bottomY - filterRect.height
                        }
                        updateFilterRect(getPosition(), true)
                    }
                }
                MouseArea {
            		id: scaleSliderMouseArea
            		anchors.fill: parent
                	acceptedButtons: Qt.NoButton
                	hoverEnabled : true
            	}
            }
            UndoButton {
                enabled: distortCheckbox.checked
                onClicked: scaleSlider.value = 100   
            }
        }
        Item { // Remplace Bouton Keyframes
            width: 20
        }
    
        //==== Ligne Alignement ====
        Label {
            text: qsTr('Alignment')
            Layout.alignment: Qt.AlignRight
        }
        RowLayout {
            Layout.columnSpan: 4
            Layout.maximumWidth: 330
            Label { text: '  ' }
            RadioButton {
            	id: leftRadioButton
            	text: 'L'
            	tooltip : 'Left'
            	exclusiveGroup: halignGroup
        	}
        	RadioButton {
            	id: centerRadioButton
            	text: 'C'
            	tooltip : 'Center'
            	exclusiveGroup: halignGroup
        	}
        	RadioButton {
            	id: rightRadioButton
            	text: 'R'
            	tooltip : 'Right'
            	exclusiveGroup: halignGroup
        	}
        	Label {
            	text: '  -  '
            }
        	RadioButton {
            	id: topRadioButton
            	text: 'T'
            	tooltip : 'Top'
            	exclusiveGroup: valignGroup
        	}
        	RadioButton {
            	id: middleRadioButton
            	text: 'M'
            	tooltip : 'Middle'
            	exclusiveGroup: valignGroup
        	}
        	RadioButton {
            	id: bottomRadioButton
            	text: 'B'
            	tooltip : 'Bottom'
            	exclusiveGroup: valignGroup
        	}
        }
        Item { // Remplace Bouton Keyframes
            width: 20
        }
		
		//==== Ligne Rotation ====
        Label {
            text: qsTr('Rotation')
            Layout.alignment: Qt.AlignRight
        }
        RowLayout {
            Layout.columnSpan: 4
            Layout.preferredWidth: 380
            SliderSpinner {
                id: rotateslider
                minimumValue: -360
                maximumValue: 360
                decimals: 1
                stepSize: 1
                suffix: ' °'
                Keys.onEnterPressed: formeCombo.forceActiveFocus()
                Keys.onReturnPressed: formeCombo.forceActiveFocus()
                onValueChanged: updateFilterRotate(getPosition())
            }
            UndoButton {
                onClicked: rotateslider.value = 0
            }
        }
        KeyframesButton {
            id: rotateKeyframesButton
            checked: filter.animateIn <= 0 && filter.animateOut <= 0 && filter.keyframeCount('rotate') > 0
            onToggled: {
                var value = rotateslider.value
                if (checked) {
                    filter.clearSimpleAnimation('rotate')
                    filter.set('rotate', value, getPosition())
                } else {
                    filter.resetProperty('rotate')
                    filter.set('rotate', value)
                }
                checked = filter.keyframeCount('rotate') > 0 && filter.animateIn <= 0 && filter.animateOut <= 0
            }
        }
        
        //==== Double l'interligne ====
        Item { 
                Layout.columnSpan: 6
                height : 5
                Layout.fillWidth: true
            }

		//==== Ligne Paramètre 1 ====
        Label {
            id: label_p1
            Layout.alignment: Qt.AlignRight
            text: labelvalues[formeCombo.currentIndex]
        }
        RowLayout {
            Layout.columnSpan: 4
            Layout.preferredWidth: 380
            SliderSpinner {
                id: slider
                enabled: label_p1.text != ""
                minimumValue: 0
                maximumValue: 100
                decimals: 1
                suffix: ' %'
                Keys.onEnterPressed: formeCombo.forceActiveFocus()
                Keys.onReturnPressed: formeCombo.forceActiveFocus()
                onValueChanged: updateFilterRadius(getPosition())
            }
            UndoButton {
                enabled: slider.enabled
                opacity: (enabled)? 1 : 0.3
                onClicked: slider.value = undovalues[formeCombo.currentIndex]
            }
        }
        KeyframesButton {
            id: radiusKeyframesButton
            enabled: slider.enabled
            checked: filter.animateIn <= 0 && filter.animateOut <= 0 && filter.keyframeCount('radius') > 0
            onToggled: {
                var value = slider.value / 100.0
                if (checked) {
                    filter.clearSimpleAnimation('radius')
                    filter.set('radius', value, getPosition())
                } else {
                    filter.resetProperty('radius')
                    filter.set('radius', value)
                }
                checked = filter.keyframeCount('radius') > 0 && filter.animateIn <= 0 && filter.animateOut <= 0
            }
        }
        
        //==== Ligne Paramètre 2 ====
        Label { 
            id: label_p2
            Layout.alignment: Qt.AlignRight
            text: labelp2values[formeCombo.currentIndex]
        }
        RowLayout {
            Layout.columnSpan: 4
            Layout.preferredWidth: 380
            SliderSpinner {
                id: param2id
                enabled: label_p2.text != ""
                minimumValue: 0
           		maximumValue: 100
                decimals: 1
                suffix: ' %'
                Keys.onEnterPressed: formeCombo.forceActiveFocus()
                Keys.onReturnPressed: formeCombo.forceActiveFocus()
                onValueChanged: updateFilterParam2(getPosition())
                ToolTip { 
                    text: 'The « Outline % » parameter is a simple multiplier of the line thickness. But it supports keyframes, so you can us it to animate the line thickness.'
                    enabled: labelp2values[formeCombo.currentIndex] == "Outline %"
                }
            }
            UndoButton {
                enabled: param2id.enabled
                opacity: (enabled)? 1 : 0.3
                onClicked: param2id.value = undo2values[formeCombo.currentIndex]
            }
        }
        KeyframesButton {
            id: param2KeyframesButton
            enabled: param2id.enabled
            checked: filter.animateIn <= 0 && filter.animateOut <= 0 && filter.keyframeCount('param2') > 0
            onToggled: {
                var value = param2id.value
                if (checked) {
                    filter.clearSimpleAnimation('param2')
                    filter.set('param2', value, getPosition())
                } else {
                    filter.resetProperty('param2')
                    filter.set('param2', value)
                }
                checked = filter.keyframeCount('param2') > 0 && filter.animateIn <= 0 && filter.animateOut <= 0
            }
        }
        
        //==== Ligne Bordure / Trait / Angles ====
        Label {
            text: qsTr('Border / Line')
            Layout.alignment: Qt.AlignRight
        }
        RowLayout {
        	Layout.columnSpan: 4
            Layout.preferredWidth: 380
        	SpinBox {
            	id: contour
            	Layout.preferredWidth: 75
            	decimals: 0
            	minimumValue: 0
           		maximumValue: profile.width
            	value: 1
            	suffix: ' px'
            	Keys.onEnterPressed: focus = false
            	Keys.onReturnPressed: focus = false
            	onValueChanged: {    
                	filter.set('border', value)
            	}
        	}
        	UndoButton {
                onClicked: contour.value = 0
            }
        	ToggleButton {
                id: proportionid
                implicitWidth: 26
            	implicitHeight: 20
            	Layout.alignment: Qt.AlignCenter
            	iconName: 'insert-link'
                iconSource: 'qrc:///icons/oxygen/32x32/actions/insert-link.png'
                tooltip: qsTr("The thickness of the outline will be proportional to the height of the frame if checked")
                onClicked: {
                    if (checked) {
                	    filter.set('propor', 1)
                	} else {
                	    filter.set('propor', 0)
                	}
                }
        	}
        	Item { Layout.fillWidth: true }
        	Label { 
        	    text: "Joints & Caps"
        	}
        	ComboBox {
            	id: aretesCombo
            	implicitWidth: 95
            	model: ['Mitered', 'Rounded', 'Beveled']
            	onActivated: {
            		if (index >= 0) {
            			filter.set('aretes', ['miter', 'round', 'bevel'][index])
            		}
                }
        	}
        	Item { width: 20 } // Remplace Undo
        }
        Item { // Remplace Bouton Keyframes
            width: 20
        }
        
        Item { 
            Layout.columnSpan: 6
            height : 0
            Layout.fillWidth: true
        } // Double l'interligne
        
        //==== Séparateur Couleurs et Opacités ====
        Rectangle {
            Layout.alignment: Qt.AlignRight
            width: 90
            height: 1
            color: "gray"
        }
        RowLayout {
            Layout.columnSpan: 5
            spacing: 5
            Label {
                text: 'Color and Opacity'
                //Layout.alignment: Qt.AlignRight
            }
            Rectangle {
                color: "gray"
                Layout.fillWidth: true
                height: 1
            }
        }
        
        //==== Ligne Couleur Forme ====
        Label {
            text: qsTr('Shape')
            Layout.alignment: Qt.AlignRight
        }
        RowLayout {
        	Layout.columnSpan: 4
            Layout.preferredWidth: 380
            RadioButton {
            	id: fillRadioButton
            	tooltip : 'Color used to fill the shape'
            	exclusiveGroup: colorGroup
            	onClicked: mastercolorSwatch.value = fillcolorSwatch.value
        	}
            ColorPicker {
            	id: fillcolorSwatch
            	alpha: true
            	eyedropper: false
            	property bool isReady: false
            	Component.onCompleted: isReady = true
            	onValueChanged: {
                	if (isReady && !blockUpdate) {
                    	filter.set('fillcolor', setOpacity(value, 100))
                    	fillopacityid.value = getOpacity(value)
                    	if (fillRadioButton.checked) mastercolorSwatch.value = value
                	}
            	}
        	}
        	SliderSpinner {
                id: fillopacityid
                minimumValue: 0
                maximumValue: 100
                //value: getOpacity(fillcolorSwatch.value)
                decimals: 0
                stepSize: 1
                suffix: ' %'
                Keys.onEnterPressed: gridposition.forceActiveFocus()
                Keys.onReturnPressed: gridposition.forceActiveFocus()
                onValueChanged: {
                    updateFilterFillopacity(getPosition())
                    // Ligne suivante nécessaire pour la mise à jour de la couleur du ColorPicker mais qui semait le bordel (création d'IC). Rajouté "&& !blockUpdate" dans le test du if (ligne 1930) pour le régler.
                    fillcolorSwatch.value = setOpacity(fillcolorSwatch.value, value)
                    if (fillRadioButton.checked) mastercolorSwatch.value = fillcolorSwatch.value
                }
            }
            UndoButton {
                onClicked: {
                    fillopacityid.value = 100
                }
            }
        }
        KeyframesButton {
            id: fillopacityKeyframesButton
            checked: filter.animateIn <= 0 && filter.animateOut <= 0 && filter.keyframeCount('fillopacity') > 0
            onToggled: {
                var value = fillopacityid.value
                if (checked) {
                    filter.clearSimpleAnimation('fillopacity')
                    filter.set('fillopacity', value, getPosition())
                }
                else {
                    filter.resetProperty('fillopacity')
                    filter.set('fillopacity', value)
                }
                checked = filter.keyframeCount('fillopacity') > 0 && filter.animateIn <= 0 && filter.animateOut <= 0
            
            }
        }
        
        //==== Ligne Couleur Bordure / Trait ====
        Label {
            text: qsTr('Border / Line')
            Layout.alignment: Qt.AlignRight
        }
        RowLayout {
        	Layout.columnSpan: 4
            Layout.preferredWidth: 380
            RadioButton {
            	id: borderRadioButton
            	tooltip : 'Border (or single line) color'
            	exclusiveGroup: colorGroup
            	onClicked: mastercolorSwatch.value = bordercolorSwatch.value
        	}
            ColorPicker {
            	id: bordercolorSwatch
            	alpha: true
            	eyedropper: false
            	property bool isReady: false
            	Component.onCompleted: isReady = true
            	onValueChanged: {
                	if (isReady && !blockUpdate) {
                    	filter.set('bordercolor', setOpacity(value, 100))
                    	borderopacityid.value = getOpacity(value)
                    	if (borderRadioButton.checked) mastercolorSwatch.value = value
                	}
            	}
        	}
        	SliderSpinner {
                id: borderopacityid
                minimumValue: 0
                maximumValue: 100
                decimals: 0
                stepSize: 1
                suffix: ' %'
                Keys.onEnterPressed: gridposition.forceActiveFocus()
                Keys.onReturnPressed: gridposition.forceActiveFocus()
                onValueChanged: {
                    updateFilterBorderopacity(getPosition())
                    // idem que fillcolor pour le pb des IC
                    bordercolorSwatch.value = setOpacity(bordercolorSwatch.value, value)
                    if (borderRadioButton.checked) mastercolorSwatch.value = bordercolorSwatch.value
                }
            }
            UndoButton {
                onClicked: {
                    borderopacityid.value = 100
                }
            }
        }
        KeyframesButton {
                id: borderopacityKeyframesButton
                checked: filter.animateIn <= 0 && filter.animateOut <= 0 && filter.keyframeCount('borderopacity') > 0
                onToggled: {
                    var value = borderopacityid.value
                    if (checked) {
                        filter.clearSimpleAnimation('borderopacity')
                        filter.set('borderopacity', value, getPosition())
                    }
                    else {
                        filter.resetProperty('borderopacity')
                        filter.set('borderopacity', value)
                    }
                    checked = filter.keyframeCount('borderopacity') > 0 && filter.animateIn <= 0 && filter.animateOut <= 0
                }
            }
        
        //==== Ligne Couleur Arrière-plan ====
        Label {
            text: qsTr('Background')
            Layout.alignment: Qt.AlignRight
        }
        RowLayout {
        	Layout.columnSpan: 4
            Layout.preferredWidth: 380
            RadioButton {
            	id: bgRadioButton
            	tooltip : 'Clip background color'
            	exclusiveGroup: colorGroup
            	onClicked: mastercolorSwatch.value = bgcolorSwatch.value
        	}
        	ColorPicker {
            	id: bgcolorSwatch
            	alpha: true
            	eyedropper: false
            	property bool isReady: false
            	Component.onCompleted: isReady = true
            	onValueChanged: {
                	if (isReady && !blockUpdate) {
                    	filter.set('color', setOpacity(value, 100))
                    	bgopacityid.value = getOpacity(value)
                    	if (bgRadioButton.checked) mastercolorSwatch.value = value
                	}
            	}
        	}
        	SliderSpinner {
                id: bgopacityid
                minimumValue: 0
                maximumValue: 100
                //value: getOpacity(bgcolorSwatch.value)
                decimals: 0
                stepSize: 1
                suffix: ' %'
                Keys.onEnterPressed: gridposition.forceActiveFocus()
                Keys.onReturnPressed: gridposition.forceActiveFocus()
                onValueChanged: {
                    updateFilterBgopacity(getPosition())
                    // idem que fillcolor pour le pb des IC
                    bgcolorSwatch.value = setOpacity(bgcolorSwatch.value, value)
                    if (bgRadioButton.checked) mastercolorSwatch.value = bgcolorSwatch.value
                }
            }
            UndoButton {
                onClicked: {
                    bgopacityid.value = 0
                }
            }
        }
        KeyframesButton {
            id: bgopacityKeyframesButton
            checked: filter.animateIn <= 0 && filter.animateOut <= 0 && filter.keyframeCount('bgopacity') > 0
            onToggled: {
                var value = bgopacityid.value
                if (checked) {
                    filter.clearSimpleAnimation('bgopacity')
                    filter.set('bgopacity', value, getPosition())
                }
                else {
                    filter.resetProperty('bgopacity')
                    filter.set('bogopacity', value)
                }
                checked = filter.keyframeCount('bgopacity') > 0 && filter.animateIn <= 0 && filter.animateOut <= 0
            }
        }
        
        //==== Ligne Alpha du clip ====
        Label {
            text: qsTr('Clip Alpha')
            Layout.alignment: Qt.AlignRight
        } // Couche Alpha du clip
        RowLayout {
            Layout.columnSpan: 4
            Layout.preferredWidth: 380
            Item { width: 18 }
            ToggleButton {
                id: refclip
                enabled: bgopacityid.value == 0
                implicitWidth: 70
                implicitHeight: 18
                text: (checked)? qsTr('Alpha = 0       ') : qsTr('Alpha = 1       ')
                tooltip: qsTr('Alpha layer of the clip')
                onCheckedChanged: {
                    if (checked) filter.set('transparent', 1)
                    else filter.set('transparent', 0)
                }
            }
            Label {
                text: "Alpha = 0 makes the clip transparent"
                opacity: 0.7
                font.pointSize: font.pointSize - 2
                font.italic : true
            }
            Item { Layout.fillWidth: true }
        }
        Item { // Remplace Bouton Keyframes
            width: 20
        }
        
        //==== Double l'interligne ====
        Item { 
            Layout.columnSpan: 6
            height : 5
            Layout.fillWidth: true
        }
        
        //==== Ligne Master Couleur ====
        Label {
            text: qsTr('Color Master')
            Layout.alignment: Qt.AlignRight
        }
        RowLayout {
        	Layout.columnSpan: 4
            Item { width: 18 }
            ColorPicker {
                id: mastercolorSwatch
                alpha: true
                property bool isReady: false
                Component.onCompleted: isReady = true
                ToolTip { text: "The color picked in the Master will be applied to the checked parameter." }
                onValueChanged: {
                    if (isReady) {
                    	//blockUpdate = true
                    	if (fillRadioButton.checked) fillcolorSwatch.value = value
                        if (borderRadioButton.checked) bordercolorSwatch.value = value
                        if (bgRadioButton.checked) bgcolorSwatch.value = value
                        //blockUpdate = false
                    }
                }
                //onPickStarted: filter.set("disable", 1)
                onPickCancelled: filter.set('disable', 0)
            }
            Item { width: 10 } //Espace
            // ===== Série de boutons ronds en couleur =====
        	Rectangle { //Bouton Transparent
            	id: transparentColor
            	implicitWidth: 12
            	implicitHeight: 12
            	color: '#00000000'
            	border.width: 1
            	border.color: 'gray'
            	radius: implicitWidth / 2
            	ToolTip {
        			parent: transparentColor
        			text: qsTr('Transparent')
        		}
            	MouseArea {
            		anchors.fill: parent
                	acceptedButtons: Qt.LeftButton
                	onPressed: mastercolorSwatch.value = setOpacity(mastercolorSwatch.value, 0)
            	}
        	}
        	Item { width: 10 } //Espace
        	Rectangle { //Bouton Noir
            	id: noirColor
            	implicitWidth: 12
            	implicitHeight: 12
            	color: '#FF000000'
            	border.width: 1
            	border.color: 'gray'
            	radius: implicitWidth / 2
            	ToolTip {
        			parent: noirColor
        			text: qsTr('Black')
        		}
            	MouseArea {
                	anchors.fill: parent
                	acceptedButtons: Qt.LeftButton
                	onPressed: mastercolorSwatch.value = '#FF000000'
            	}
        	}
        	Rectangle { //Bouton Blanc
            	id: blancColor
            	implicitWidth: 12
            	implicitHeight: 12
            	color: '#FFFFFFFF'
            	border.width: 1
            	border.color: 'gray'
            	radius: implicitWidth / 2
            	ToolTip {
        			parent: blancColor
        			text: qsTr('White')
        		}
            	MouseArea {
                	anchors.fill: parent
                	acceptedButtons: Qt.LeftButton
                	onPressed: mastercolorSwatch.value = '#FFFFFFFF'
            	}
        	}
        	Rectangle { //Bouton Rouge
            	implicitWidth: 12
            	implicitHeight: 12
            	color: '#FFFF0000'
            	border.width: 1
            	border.color: 'gray'
            	radius: implicitWidth / 2
            	MouseArea {
                	anchors.fill: parent
                	acceptedButtons: Qt.LeftButton
                	onPressed: mastercolorSwatch.value = '#FFFF0000'
            	}
        	}
        	Rectangle { //Bouton Orange
            	implicitWidth: 12
            	implicitHeight: 12
            	color: '#FFFF7F00'
            	border.width: 1
            	border.color: 'gray'
            	radius: implicitWidth / 2
            	MouseArea {
                	anchors.fill: parent
                	acceptedButtons: Qt.LeftButton
                	onPressed: mastercolorSwatch.value = '#FFFF7F00'
            	}
        	}
        	Rectangle { //Bouton Jaune
            	implicitWidth: 12
            	implicitHeight: 12
            	color: '#FFFFFF00'
            	border.width: 1
            	border.color: 'gray'
            	radius: implicitWidth / 2
            	MouseArea {
                	anchors.fill: parent
                	acceptedButtons: Qt.LeftButton
                	onPressed: mastercolorSwatch.value = '#FFFFFF00'
            	}
        	}
        	Rectangle { //Bouton Vert
            	implicitWidth: 12
            	implicitHeight: 12
            	color: '#FF00FF00'
            	border.width: 1
            	border.color: 'gray'
            	radius: implicitWidth / 2
            	MouseArea {
                	anchors.fill: parent
                	acceptedButtons: Qt.LeftButton
                	onPressed: mastercolorSwatch.value = '#FF00FF00'
            	}
        	}
        	Rectangle { //Bouton Cyan
            	implicitWidth: 12
            	implicitHeight: 12
            	color: '#FF00FFFF'
            	border.width: 1
            	border.color: 'gray'
            	radius: implicitWidth / 2
            	MouseArea {
                	anchors.fill: parent
                	acceptedButtons: Qt.LeftButton
                	onPressed: mastercolorSwatch.value = '#FF00FFFF'
            	}
        	}
        	Rectangle { //Bouton Bleu
            	implicitWidth: 12
            	implicitHeight: 12
            	color: '#FF0000FF'
            	border.width: 1
            	border.color: 'gray'
            	radius: implicitWidth / 2
            	MouseArea {
                	anchors.fill: parent
                	acceptedButtons: Qt.LeftButton
                	onPressed: mastercolorSwatch.value = '#FF0000FF'
            	}
        	}
        	Rectangle { //Bouton Violet
            	implicitWidth: 12
            	implicitHeight: 12
            	color: '#FF7F007F'
            	border.width: 1
            	border.color: 'gray'
            	radius: implicitWidth / 2
            	MouseArea {
                	anchors.fill: parent
                	acceptedButtons: Qt.LeftButton
                	onPressed: mastercolorSwatch.value = '#FF7F007F'
            	}
        	}
        	Rectangle { //Bouton Magenta
            	implicitWidth: 12
            	implicitHeight: 12
            	color: '#FFFF00FF'
            	border.width: 1
            	border.color: 'gray'
            	radius: implicitWidth / 2
            	MouseArea {
                	anchors.fill: parent
                	acceptedButtons: Qt.LeftButton
                	onPressed: mastercolorSwatch.value = '#FFFF00FF'
            	}
        	}
        	Rectangle { //Bouton Brun
            	implicitWidth: 12
            	implicitHeight: 12
            	color: '#FF996633'
            	border.width: 1
            	border.color: 'gray'
            	radius: implicitWidth / 2
            	MouseArea {
                	anchors.fill: parent
                	acceptedButtons: Qt.LeftButton
                	onPressed: mastercolorSwatch.value = '#FF996633'
            	}
        	}
        	//===== Fin de la série de boutons ronds en couleur =====
        	Item { width: 20 } // Remplace Undo
        }
        Item { // Remplace Bouton Keyframes
            width: 20
        }
    }

    function updateFilter() {
        updateFilterRadius(null)
        updateFilterParam2(null)
        updateFilterFillopacity(null)
        updateFilterBorderopacity(null)
        updateFilterBgopacity(null)
        updateFilterRotate(null)
        updateFilterRect(null)
    }
    
    Connections {
        target: filter
        onChanged: {
            setRectControls()
            //setRotateControls() // pas sûr nécessaire
        }
        onInChanged: updateFilter()
        onOutChanged: updateFilter()
        onAnimateInChanged: updateFilter()
        onAnimateOutChanged: updateFilter()
    }

    Connections {
        target: producer
        onPositionChanged: {
            //if (label_p1.text != "") setRadiusControls()
            //if (label_p2.text != "") setParam2Controls()
            setRadiusControls()
            setParam2Controls()
            setFillopacityControls()
            setBorderopacityControls()
            setBgopacityControls()
            setRotateControls()
            setRectControls()
        }
    }
    
    function labelp1_ligne() {
        if (nombre.value == 11) return "Dash length"
        else return "Length"
    }
    
    function labelp2_ligne() {
        if (nombre.value <= 4) return "Y Offset"
        else if (nombre.value <= 8) return "X Offset"
        else if (nombre.value <= 10) return ""
        else if (nombre.value == 11) return "Spacing length"
        else return "Gradient"
    }
    MessageDialog {
        id: help_Ligne_Dialog
        visible: false
        modality: Qt.ApplicationModal
        icon: StandardIcon.Information
        text: qsTr(""
        + "<u style='font-size: x-large'>Single line - Variants :</u><p><br>"
        + "<u style='color: yellow'>Horizontal Line</u><br>"
        + "1 : Drawn from left to right.<br>"
        + "2 : Drawn from right to left.<br>"
        + "3 : Drawn from center to extremities.<br>"
        + "4 : Drawn from extremities to Center.<p>"
        + "<u style='color: yellow'> Vertical Line</u><br>"
        + "5 : Drawn from top to bottom.<br>"
        + "6 : Drawn from bottom to top.<br>"
        + "7 : Drawn from center to extremities.<br>"
        + "8 : Drawn from extremities to Center.<p>"
        + "<u style='color: yellow'>Diagonal Line</u><br>"
        + "9 : Top-left to Bottom-right.<br>"
        + "10 : Top-right to Bottom-left.<p>"
        + "<u style='color: yellow'>Special Lines</u><br>"
        + "11 : Dashed line.<br>"
        + "12 : Pointed line.<p>"
        + "Line thickness is not keyframable. Instead you can use the 'Rectangle Wrap' shape which offers this possibility.<p>")
        standardButtons: StandardButton.Ok
    } // Aide Ligne simple
    
    MessageDialog {
        id: help_Habillage_Dialog
        visible: false
        modality: Qt.ApplicationModal
        icon: StandardIcon.Information
        text: qsTr(""
        + "<u style='font-size: x-large'>Rectangle Wrap :</u><p><br>"
        + "<u style='color: yellow'>Choose which borders will be drawn</u><p>"
        + " -2 : Two diagonals.<br>"
        + " -1 : Diagonal: Top-right to Bottom-left.<br>"
        + "  0 : Diagonal: Top-left to Bottom-right.<br><br>"
        + "  1 : Top side.<br>"
        + "  2 : Left side.<br>"
        + "  3 : Left + Top sides.<br>"
        + "  4 : Bottom side.<br>"
        + "  5 : Top + Bottom sides.<br>"
        + "  6 : Left + Bottom sides.<br>"
        + "  7 : Top + Left + Bottom sides.<br>"
        + "  8 : Bottom side.<br>"
        + "  9 : Top + Right sides.<br>"
        + " 10 : Left + Right sides.<br>"
        + " 11 : Left + Top + Right sides.<br>"
        + " 12 : Right + Bottom sides.<br>"
        + " 13 : Top + Right + Bottom sides.<br>"
        + " 14 : Left + Right + Bottom sides.<br>"
        + " 15 : All four sides.<p>"
        + "<p style='color: yellow'>The « Outline % » parameter is a simple multiplier of the line thickness. But it supports keyframes, so you can us it to animate the line thickness.<p>")
        standardButtons: StandardButton.Ok
    } // Aide Habillage Rectangle
}
